## faust 0.9.95~repack1

=== Makefile ===
version := 0.9.95

DESTDIR ?= 
PREFIX ?= /usr/local
CROSS=i586-mingw32msvc-

MAKEFILE := Makefile.unix

system	?= $(shell uname -s)

ifeq ($(system), Darwin)
LIB_EXT = dylib
else
ifneq ($(findstring MINGW32, $(system)),)
LIB_EXT = dll
EXE = .exe
else
LIB_EXT = so
endif
endif

prefix := $(DESTDIR)$(PREFIX)
arch   := $(wildcard architecture/*.*)
mfiles := $(wildcard examples/Makefile.*)
vname := faust-$(version)-$(shell date +%y%m%d.%H%M%S)
zname := faust-$(version)

.PHONY: all world dynamic httpd win32 sound2faust

all :
	$(MAKE) -C compiler -f $(MAKEFILE) prefix=$(prefix)
	$(MAKE) -C architecture/osclib

# make world: This builds all the common targets for a fairly complete Faust
# installation: Faust compiler, sound2faust utility, OSC and HTTPD libraries
# (both static and dynamic). Most of the extra targets require additional
# dependencies and hence aren't built by default; please check the Faust
# README for details. This target may be built in parallel (make -j).
world : all sound2faust httpd dynamic

dynamic : all httpd
	$(MAKE) -C architecture/httpdlib/src dynamic PREFIX=$(PREFIX)
	$(MAKE) -C architecture/osclib dynamic PREFIX=$(PREFIX)

httpd :
	$(MAKE) -C architecture/httpdlib/src

win32 :
	$(MAKE) -C compiler -f $(MAKEFILE) prefix=$(prefix) CXX=$(CROSS)g++
	$(MAKE) -C architecture/osclib CXX=$(CROSS)g++ system=Win32

sound2faust: 

	$(MAKE) -C tools/sound2faust

.PHONY: clean depend install ininstall dist parser help

help :
	@echo "Usage : 'make; sudo make install'"
	@echo "For http support : 'make httpd; make; sudo make install' (requires GNU libmicrohttpd)"
	@echo "make or make all : compile the Faust compiler and osc support library"
	@echo "make httpd : compile httpdlib (requires GNU libmicrohttpd)"
	@echo "make dynamic : compile httpd & osc supports as dynamic libraries"
	@echo "make sound2faust : compile sound to DSP file converter"
	@echo "make parser : generate the parser from the lex and yacc files"
	@echo "make clean : remove all object files"
	@echo "make doc : generate the documentation using doxygen"
	@echo "make doclib : generate the documentation of the faust libraries"
	@echo "make install : install the compiler, tools and the architecture files in $(prefix)/bin $(prefix)/share/faust $(prefix)/include/faust"
	@echo "make uninstall : undo what install did"
	@echo "make dist : make a Faust distribution as a .zip file"
	@echo "make log : make a changelog file"

parser :
	$(MAKE) -C compiler -f $(MAKEFILE) parser

clean :
	$(MAKE) -C compiler -f $(MAKEFILE) clean
	$(MAKE) -C architecture/osclib clean
	$(MAKE) -C architecture/httpdlib/src clean
	$(MAKE) -C tools/sound2faust clean

depend :
	$(MAKE) -C compiler -f $(MAKEFILE) depend
	$(MAKE) -C architecture/osclib depend
	$(MAKE) -C architecture/httpdlib/src depend


doc :
	$(MAKE) -C compiler -f $(MAKEFILE) doc

doclib :
	./libraries/generateDoc


install :
	# install faust itself
	mkdir -p $(prefix)/bin/
	mkdir -p $(prefix)/lib/
	mkdir -p $(prefix)/include/
	mkdir -p $(prefix)/include/faust/
	mkdir -p $(prefix)/include/faust/osc/
	install compiler/faust $(prefix)/bin/
	# install architecture and faust library files
	mkdir -p $(prefix)/share/faust
	cp architecture/*.cpp $(prefix)/share/faust/
	cp libraries/old/*.lib $(prefix)/share/faust/
	cp libraries/*.lib $(prefix)/share/faust/
	# This is needed by faust2lv2 -gui / lv2ui.cpp.
	cp architecture/lv2qtgui.h $(prefix)/share/faust/
	# This is needed by faust2faustvst -gui / faustvst.cpp.
	cp architecture/faustvstqt.h $(prefix)/share/faust/
	# install iOS
	rm -rf $(prefix)/share/faust/iOS
	cp -r architecture/iOS $(prefix)/share/faust/
	cp -r architecture/osclib $(prefix)/share/faust/iOS
	rm -rf $(prefix)/share/faust/iOS/DerivedData/
	rm -rf $(prefix)/share/faust/iOSKeyboard
	cp -r architecture/iOSKeyboard $(prefix)/share/faust/
	# install Juce
	rm -rf $(prefix)/share/faust/template_jucer
	cp -r architecture/template_jucer $(prefix)/share/faust/
	# install AU
	rm -rf $(prefix)/share/faust/AU/
	cp -r architecture/AU $(prefix)/share/faust/
	cp -r architecture/android $(prefix)/share/faust/
	cp -r architecture/api $(prefix)/share/faust/
	cp -r architecture/max-msp $(prefix)/share/faust/

	# install math documentation files
	cp architecture/mathdoctexts-*.txt $(prefix)/share/faust/
	cp architecture/latexheader.tex $(prefix)/share/faust/
	# install additional binary libraries (osc, http,...)
	([ -e architecture/httpdlib/libHTTPDFaust.a ] && cp architecture/httpdlib/libHTTPDFaust.a $(prefix)/lib/) || echo libHTTPDFaust.a not available
	([ -e architecture/httpdlib/libHTTPDFaust.$(LIB_EXT) ] && cp architecture/httpdlib/libHTTPDFaust.$(LIB_EXT) $(prefix)/lib/) || echo libHTTPDFaust.$(LIB_EXT) not available
		
	([ -e architecture/osclib/libOSCFaust.a ] && cp architecture/osclib/libOSCFaust.a $(prefix)/lib/) || echo libOSCFaust.a not available
	([ -e architecture/osclib/libOSCFaust.$(LIB_EXT) ] && cp -a architecture/osclib/libOSCFaust*.$(LIB_EXT)* $(prefix)/lib/) || echo libOSCFaust.$(LIB_EXT) not available
	
	cp -r architecture/httpdlib/html/js $(prefix)/share/faust/js
	([ -e architecture/httpdlib/src/hexa/stylesheet ] && cp architecture/httpdlib/src/hexa/stylesheet $(prefix)/share/faust/js/stylesheet.js) || echo stylesheet not available
	([ -e architecture/httpdlib/src/hexa/jsscripts ] && cp architecture/httpdlib/src/hexa/jsscripts $(prefix)/share/faust/js/jsscripts.js) || echo jsscripts not available
	# install includes files for architectures
	cp -r architecture/faust $(prefix)/include/
	# install additional includes files for binary libraries  (osc, http,...)
	cp architecture/osclib/faust/faust/OSCControler.h $(prefix)/include/faust/gui/
	cp architecture/osclib/faust/faust/osc/*.h $(prefix)/include/faust/osc/
	cp architecture/httpdlib/src/include/*.h $(prefix)/include/faust/gui/
	# install faust2xxx tools
	make -C tools/faust2appls install
	# install sound2faust converter
	[ -e tools/sound2faust/sound2faust ] && make -C tools/sound2faust install || echo sound2faust not compiled
	# install webaudio
	cp -r architecture/webaudio $(prefix)/share/faust/
	# install Max/MSP
	cp -r architecture/max-msp $(prefix)/share/faust/
        


uninstall :
	rm -f $(addprefix $(prefix)/lib/, libHTTPDFaust.a libHTTPDFaust.$(LIB_EXT) libOSCFaust.a libOSCFaust*.$(LIB_EXT)*)
	rm -rf $(prefix)/share/faust/
	rm -rf $(prefix)/include/faust/
	rm -f $(prefix)/bin/faust$(EXE)
	make -C tools/faust2appls uninstall
	rm -f $(prefix)/bin/sound2faust$(EXE)

# make a faust distribution .zip file
dist :
	git archive --format=tar.gz -o faust-$(version).tgz --prefix=faust-$(version)/ HEAD


log :
	git log --oneline --date-order --reverse --after={2014-05-19} master >log-$(version)

# Make Debian packages. This builds a package from the current HEAD in a
# subdirectory named $(debdist). It also creates the source archive that goes
# along with it. All files will be created in the toplevel Faust source
# directory.

# To make this work, you need to have the Debian package toolchain (debuild
# and friends) installed. Also make sure you have your DEBEMAIL and
# DEBFULLNAME environment variables set up as explained in the debchange(1)
# manual page. These are needed to create changelog entries and in order to
# sign the Debian packages created with 'make deb' and 'make debsrc'.

# The typical workflow is as follows:

# 1. Run 'make debchange' once to create a new debian/changelog entry. You
# *must* do this once so that debuild knows about the proper version number of
# the package.

# 2. Run 'make deb' to build a signed binary package. Or 'make deb-us' for an
# unsigned one.

# If you only need the binary package for local deployment then you're done.
# Otherwise proceed to step 3.

# 3. Run 'make debsrc' to create a signed Debian source package which can be
# uploaded, e.g, to Launchpad using 'dput'. Or 'make debsrc-us' for an
# unsigned package.

# 4. Run 'make debclean' to get rid of any files that were created in steps 2
# and 3.

# The Debian version gets derived from the package version $(version) as well
# as the date and serial number of the last commit.
debversion = $(version)+git$(shell git log -1 --format=%cd --date=short 2>/dev/null | sed -e 's/-//g')+$(shell git rev-list --count HEAD 2>/dev/null)
# Debian revision number of the package.
debrevision = 1
# Source tarball and folder.
debsrc = faust_$(debversion).orig.tar.gz
debdist = faust-$(debversion)

# This is used for automatically generated debian/changelog entries (cf. 'make
# debchange'). Adjust as needed.
debmsg = "Build from latest upstream source."
debprio = "low"

.PHONY: debversion debchange debclean deb debsrc deb-us debsrc-us

debversion:
	@echo $(debversion)

debchange:
	dch -u $(debprio) -v $(debversion)-$(debrevision) $(debmsg) && dch -r ""

debclean: $(debsrc)
	rm -rf $(debdist)
	rm -f faust_$(version)+git*

deb: $(debsrc)
	rm -rf $(debdist)
	tar xfz $(debsrc)
# Here we just copy debian/ from the working copy since it might have changes
# that haven't been committed yet.
	cd $(debdist) && cp -R ../debian . && debuild $(DEBUILD_FLAGS)
	rm -rf $(debdist)

debsrc:
	$(MAKE) deb DEBUILD_FLAGS=-S

deb-us:
	$(MAKE) deb DEBUILD_FLAGS="-us -uc"

debsrc-us:
	$(MAKE) deb DEBUILD_FLAGS="-S -us -uc"

$(debsrc) :
	git archive --format=tar.gz -o $(debsrc) --prefix=$(debdist)/ HEAD

# DO NOT DELETE

=== benchmark/Makefile ===
system	:= $(shell uname -s)

ifeq ($(system), Darwin)
MYGCCFLAGS := '-O3  -mfpmath=sse -msse -msse2 -msse3 -ffast-math -ftree-vectorize'
else
MYGCCFLAGS := '-O3 -march=native -mfpmath=sse -msse -msse2 -msse3 -ffast-math -ftree-vectorize'
endif

MYICCFLAGS := '-O3 -xHost -ftz -fno-alias -fp-model fast=2' 

VSIZE := 1024

all : icc gcc
icc : ialsascal ialsavec ialsavec2 ialsavec4 ialsaomp2 ialsasch ialsasch2
gcc : galsascal galsavec galsavec2 galsavec4 galsaomp2 galsasch galsasch2
osx : gcoreaudioscal gcoreaudiovec1 gcoreaudiovec2 gcoreaudiovec3 gcoreaudiovec4 gcoreaudiosch gcoreaudiosch2


### intel-compiler single-precision x {scalar, vector and openMP}

ialsascal :
	install -d ialsascaldir
	$(MAKE) DEST='ialsascaldir/' ARCH='alsa-gtk-bench.cpp' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsasch :
	install -d ialsaschdir
	$(MAKE) DEST='ialsaschdir/' ARCH='alsa-gtk-bench.cpp' VEC='-sch -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsasch2 :
	install -d ialsasch2dir
	$(MAKE) DEST='ialsasch2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-sch -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsavec :
	install -d ialsavecdir
	$(MAKE) DEST='ialsavecdir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsavec1 :
	install -d ialsavec1dir
	$(MAKE) DEST='ialsavec1dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -lv 1 -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsavec2 :
	install -d ialsavec2dir
	$(MAKE) DEST='ialsavec2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -dfs -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsavec3 :
	install -d ialsavec3dir
	$(MAKE) DEST='ialsavec3dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsavec4 :
	install -d ialsavec4dir
	$(MAKE) DEST='ialsavec4dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -g -vs 16' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

ialsaomp :
	install -d ialsaompdir
	$(MAKE) DEST='ialsaompdir/' ARCH='alsa-gtk-bench.cpp' VEC='-omp -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS='-openmp '$(MYICCFLAGS) -f Makefile.compile

ialsaomp2 :
	install -d ialsaomp2dir
	$(MAKE) DEST='ialsaomp2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-omp -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS='-openmp '$(MYICCFLAGS) -f Makefile.compile



### gcc-compiler single-precision x {scalar, vector and openMP}

galsascal :
	install -d galsascaldir
	$(MAKE) DEST='galsascaldir/' ARCH='alsa-gtk-bench.cpp' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsasch :
	install -d galsaschdir
	$(MAKE) DEST='galsaschdir/' ARCH='alsa-gtk-bench.cpp' VEC='-sch -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsasch2 :
	install -d galsasch2dir
	$(MAKE) DEST='galsasch2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-sch -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsavec :
	install -d galsavecdir
	$(MAKE) DEST='galsavecdir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsavec1 :
	install -d galsavec1dir
	$(MAKE) DEST='galsavec1dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -lv 1 -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsavec2 :
	install -d galsavec2dir
	$(MAKE) DEST='galsavec2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -dfs -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsavec3 :
	install -d galsavec3dir
	$(MAKE) DEST='galsavec3dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsavec4 :
	install -d galsavec4dir
	$(MAKE) DEST='galsavec4dir/' ARCH='alsa-gtk-bench.cpp' VEC='-vec -g -vs 16' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

galsaomp :
	install -d galsaompdir
	$(MAKE) DEST='galsaompdir/' ARCH='alsa-gtk-bench.cpp' VEC='-omp -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS='-fopenmp '$(MYGCCFLAGS) -f Makefile.compile

galsaomp2 :
	install -d galsaomp2dir
	$(MAKE) DEST='galsaomp2dir/' ARCH='alsa-gtk-bench.cpp' VEC='-omp -g -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS='-fopenmp '$(MYGCCFLAGS) -f Makefile.compile

gcoreaudioscal :
	install -d gcoreaudioscaldir
	$(MAKE) DEST='gcoreaudioscaldir/' ARCH='coreaudio-gtk-bench.cpp' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiovec1 :
	install -d gcoreaudiovec1dir
	$(MAKE) DEST='gcoreaudiovec1dir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-vec -lv 1 -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiovec2 :
	install -d gcoreaudiovec2dir
	$(MAKE) DEST='gcoreaudiovec2dir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-vec -dfs -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiovec3 :
	install -d gcoreaudiovec3dir
	$(MAKE) DEST='gcoreaudiovec3dir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-vec -g -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiovec4 :
	install -d gcoreaudiovec4dir
	$(MAKE) DEST='gcoreaudiovec4dir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-vec -dfs -g -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiosch :
	install -d gcoreaudioschdir
	$(MAKE) DEST='gcoreaudioschdir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-sch -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

gcoreaudiosch2 :
	install -d gcoreaudiosch2dir
	$(MAKE) DEST='gcoreaudiosch2dir/' ARCH='coreaudio-gtk-bench.cpp' VEC='-sch -g -vs $(VSIZE)' LIB='-lpthread -framework CoreAudio -framework AudioUnit -framework CoreServices `pkg-config --cflags --libs gtk+-2.0`' CXX='g++' CXXFLAGS=$(MYGCCFLAGS) -f Makefile.compile

### intel-compiler double-precision x {scalar, vector and openMP}

idalsascal :
	install -d idalsascaldir
	$(MAKE) DEST='idalsascaldir/' ARCH='alsa-gtk-bench.cpp' VEC='-double' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

idalsavec :
	install -d idalsavecdir
	$(MAKE) DEST='idalsavecdir/' ARCH='alsa-gtk-bench.cpp' VEC='-double -vec -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

idalsaomp :
	install -d idalsaompdir
	$(MAKE) DEST='idalsaompdir/' ARCH='alsa-gtk-bench.cpp' VEC='-double -omp -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS='-openmp '$(MYICCFLAGS) -f Makefile.compile

### intel-compiler quad-precision x {scalar, vector and openMP}

iqalsascal :
	install -d iqalsascaldir
	$(MAKE) DEST='iqalsascaldir/' ARCH='alsa-gtk-bench.cpp' VEC='-quad' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

iqalsavec :
	install -d iqalsavecdir
	$(MAKE) DEST='iqalsavecdir/' ARCH='alsa-gtk-bench.cpp' VEC='-quad -vec -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS=$(MYICCFLAGS) -f Makefile.compile

iqalsaomp :
	install -d iqalsaompdir
	$(MAKE) DEST='iqalsaompdir/' ARCH='alsa-gtk-bench.cpp' VEC='-quad -omp -vs $(VSIZE)' LIB='-lpthread -lasound  `pkg-config --cflags --libs gtk+-2.0`' CXX='icc' CXXFLAGS='-openmp '$(MYICCFLAGS) -f Makefile.compile


clean :
	rm -rf *dir

=== architecture/osclib/Makefile ===
###############################################################
#
#			Build liboscpack.a and libOSCFaust.a the 2
#			static libraries needed to provide support
#           for Open Sound Control in Faust generated
#           applications.
#			
###############################################################
VERSION=0.95
SOVERSION=0

.PHONY: all clean depend

system	?= $(shell uname -s)

ifeq ($(system), Darwin)
ARCHFLAGS :=  -arch i386 -arch x86_64
LIB_EXT = dylib
TARGET = libOSCFaust.$(VERSION).$(LIB_EXT)
LIB_SONAME = libOSCFaust.$(SOVERSION).$(LIB_EXT)
else
ARCHFLAGS := 
ifneq ($(findstring MINGW32, $(system)),)
LIB_EXT = dll
TARGET = libOSCFaust-$(VERSION).$(LIB_EXT)
LIB_SONAME = libOSCFaust-$(SOVERSION).$(LIB_EXT)
else
CXXFLAGS += -fPIC
LIB_EXT = so
TARGET = libOSCFaust.$(LIB_EXT).$(VERSION)
LIB_SONAME = libOSCFaust.$(LIB_EXT).$(SOVERSION)
endif
endif

LIB_NAME = libOSCFaust.$(LIB_EXT)

all : liboscpack.a libOSCFaust.a

dynamic : liboscpack.a $(TARGET)


liboscpack.a : oscpack/liboscpack.a
	cp oscpack/liboscpack.a $@

libOSCFaust.a : liboscpack.a faust/libOSCFaust.a
	cp faust/libOSCFaust.a $@
# This "links" liboscpack.a into libOSCFaust.a.
ifeq ($(system), Darwin)
# On Darwin, we need to use Apple's libtool here, since ar can't handle
# archives containing more than one architecture.
	libtool libOSCFaust.a liboscpack.a -o tmp.a && rm -f libOSCFaust.a && mv tmp.a libOSCFaust.a
else
# Other systems use ar. The following should work with most systems having a
# modern ar (including GNU ar), but may need adjustments for systems with
# older ar versions or fat binaries like on OS X.
	(rm -Rf tmpdir && mkdir tmpdir && cd tmpdir && ar x ../liboscpack.a && ar q ../libOSCFaust.a `ar t ../liboscpack.a | grep .o` && cd .. && rm -Rf tmpdir)
# Older ar versions might need this?
#	ranlib $@
endif

$(TARGET) : faust/$(TARGET)
	cp faust/$(TARGET) $@
	ln -sf $(TARGET) $(LIB_SONAME)
	ln -sf $(LIB_SONAME) $(LIB_NAME)

	
oscpack/liboscpack.a:
	make -C oscpack
	
faust/libOSCFaust.a:
	make -C faust
	
faust/$(TARGET):
	make -C faust VERSION=$(VERSION) SOVERSION=$(SOVERSION) PREFIX=$(PREFIX) MODE=SHARED

ios : 
	make -C oscpack ios
	make -C faust ios
	
clean :
	rm -f liboscpack.a libOSCFaust.a
	rm -f libOSCFaust*.dylib libOSCFaust.so* libOSCFaust*.dll
	make -C oscpack clean
	make -C faust clean

depend :
	make -C oscpack depend
	make -C faust depend

=== documentation/faust-quick-reference-src/Makefile ===
faust-quick-reference.pdf : faust-quick-reference.tex chapters/*.tex
	pdflatex faust-quick-reference.tex
	rail faust-quick-reference
	pdflatex faust-quick-reference.tex
	
clean :
	rm -f *.out *.toc *.pdf *.aux *.dvi *.rai *.rao *.log *~

=== tools/faust2appls/Makefile ===
DESTDIR ?=
PREFIX ?= /usr/local

MAKEFILE := Makefile.unix

prefix := $(DESTDIR)$(PREFIX)
dest   := $(prefix)/bin

help:
	@echo This is a makefile to install the Faust tools.
	@echo The only target is 'install'. Install directory is $(dest) by default.
	@echo Call 'make install DESTDIR=/your/install/dir' to install to another location.

install:
	mkdir -p $(dest)
	install ../faust2sc-1.0.0/faust2sc $(dest)
	install faust2alqt $(dest)
	install faust2alsa $(dest)
	install faust2alsaconsole $(dest)
	install faust2android $(dest)
	install faust2api $(dest)
	install faust2asmjs $(dest)
	install faust2au $(dest)
	install faust2caqt $(dest)
	install faust2bela $(dest)
	install faust2caqtios $(dest)
	install faust2csound $(dest)
	install faust2dssi $(dest)
	install faust2eps $(dest)
	install faust2faustvst $(dest)
	install faust2firefox $(dest)
	install faust2graph $(dest)
	install faust2graphviewer $(dest)
	install faust2ios $(dest)
	install faust2iosKeyboard $(dest)
	install faust2jack $(dest)
	install faust2jackconsole $(dest)
	install faust2jackinternal $(dest)
	install faust2jackserver $(dest)
	install faust2jaqt $(dest)
	install faust2juce $(dest)
	install faust2ladspa $(dest)
	install faust2lv2 $(dest)
	install faust2mathdoc $(dest)
	install faust2mathviewer $(dest)
	install faust2max6 $(dest)
	install faust2md $(dest)
	install faust2msp $(dest)
	install faust2netjackconsole $(dest)
	install faust2netjackqt $(dest)
	install faust2octave $(dest)
	install faust2owl $(dest)
	install faust2paqt $(dest)
	install faust2pdf $(dest)
	install faust2plot $(dest)
	install faust2png $(dest)
	install faust2puredata $(dest)
	install faust2raqt $(dest)
	install faust2ros $(dest)
	install faust2rosgtk $(dest)
	install faust2rpialsaconsole $(dest)
	install faust2rpinetjackconsole $(dest)
	install faust2sig $(dest)
	install faust2sigviewer $(dest)
	install faust2supercollider $(dest)
	install faust2svg $(dest)
	install faust2vst $(dest)
	install faust2vsti $(dest)
	install faust2w32max6 $(dest)
	install faust2w32msp $(dest)
	install faust2w32puredata $(dest)
	install faust2w32vst $(dest)
	install faust2webaudioasm $(dest)
	install faustoptflags $(dest)
	install faustpath $(dest)

uninstall:
	rm -f $(dest)/faust2sc
	rm -f $(dest)/faust2alqt
	rm -f $(dest)/faust2alsa
	rm -f $(dest)/faust2alsaconsole
	rm -f $(dest)/faust2android
	rm -f $(dest)/faust2api
	rm -f $(dest)/faust2asmjs
	rm -f $(dest)/faust2au
	rm -f $(dest)/faust2bela
	rm -f $(dest)/faust2caqt
	rm -f $(dest)/faust2caqtios
	rm -f $(dest)/faust2csound
	rm -f $(dest)/faust2dssi
	rm -f $(dest)/faust2eps
	rm -f $(dest)/faust2faustvst
	rm -f $(dest)/faust2firefox
	rm -f $(dest)/faust2graph
	rm -f $(dest)/faust2graphviewer
	rm -f $(dest)/faust2ios
	rm -f $(dest)/faust2iosKeyboard
	rm -f $(dest)/faust2jack
	rm -f $(dest)/faust2jackconsole
	rm -f $(dest)/faust2jackinternal
	rm -f $(dest)/faust2jackserver
	rm -f $(dest)/faust2jaqt
	rm -f $(dest)/faust2juce
	rm -f $(dest)/faust2ladspa
	rm -f $(dest)/faust2lv2
	rm -f $(dest)/faust2mathdoc
	rm -f $(dest)/faust2mathviewer
	rm -f $(dest)/faust2max6
	rm -f $(dest)/faust2md
	rm -f $(dest)/faust2msp
	rm -f $(dest)/faust2netjackconsole
	rm -f $(dest)/faust2netjackqt
	rm -f $(dest)/faust2octave
	rm -f $(dest)/faust2owl
	rm -f $(dest)/faust2paqt
	rm -f $(dest)/faust2pdf
	rm -f $(dest)/faust2plot
	rm -f $(dest)/faust2png
	rm -f $(dest)/faust2puredata
	rm -f $(dest)/faust2raqt
	rm -f $(dest)/faust2ros
	rm -f $(dest)/faust2rosgtk
	rm -f $(dest)/faust2rpialsaconsole
	rm -f $(dest)/faust2rpinetjackconsole
	rm -f $(dest)/faust2sig
	rm -f $(dest)/faust2sigviewer
	rm -f $(dest)/faust2supercollider
	rm -f $(dest)/faust2svg
	rm -f $(dest)/faust2vst
	rm -f $(dest)/faust2vsti
	rm -f $(dest)/faust2w32max6
	rm -f $(dest)/faust2w32msp
	rm -f $(dest)/faust2w32puredata
	rm -f $(dest)/faust2w32vst
	rm -f $(dest)/faust2webaudioasm
	rm -f $(dest)/faustoptflags
	rm -f $(dest)/faustpath

=== tools/faust2pd/Makefile ===

# Package name and version number:
dist = faust2pd-$(version)
version = 2.9

# Default installation prefix:
prefix = /usr/local

# Try to guess the Pd installation prefix:
pdprefix = $(patsubst %/bin/pd,%,$(shell which pd 2>/dev/null))
ifeq ($(strip $(pdprefix)),)
# Fall back to /usr/local.
pdprefix = /usr/local
endif

bindir = $(prefix)/bin
# where to install the Pd stuff
libdir = $(pdprefix)/lib
datadir = $(libdir)/pd/extra

# Try to guess the host system type and do platform-specific setup.
host = $(shell ./config.guess)
ifneq "$(findstring -mingw,$(host))" ""
# Windows
EXE = .exe
endif

DESTDIR=

DISTFILES = Makefile COPYING ChangeLog README config.guess *.pure *.pd examples/README debian/* examples/*/Makefile examples/*/*.cpp examples/*/*.dsp examples/*/*.syn examples/*/*.pd examples/*/*.pure examples/*/*.xml pd/*.h
SEDFILES = README

.PHONY: all examples clean distclean realclean install uninstall

all: faust2pd$(EXE)

examples: faust2pd$(EXE)
	for x in basic faust synth seqdemo; do make -C examples/$$x all; done

clean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do make -C examples/$$x clean; done

distclean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do make -C examples/$$x distclean; done

realclean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do make -C examples/$$x realclean; done

# as of pure-0.21, we can compile the script to an executable
faust2pd$(EXE): faust2pd.pure faustxml.pure
	sed -e 's?@version@?$(version)?' < $< > xx$<
	pure $(PUREC_FLAGS) -I. -c xx$< -o $@
	rm -f xx$<

# install faust2pd
install:
	test -d $(DESTDIR)$(bindir) || mkdir -p $(DESTDIR)$(bindir)
	cp faust2pd$(EXE) $(DESTDIR)$(bindir)
	strip $(DESTDIR)$(bindir)/faust2pd$(EXE)
ifeq "$(findstring -mingw,$(host))" ""
	chmod a+x $(DESTDIR)$(bindir)/faust2pd$(EXE)
endif
	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
	@echo "Optionally, you can also run make install-pd to install the auxiliary Faust"
	@echo "abstractions in $(DESTDIR)$(datadir)."
	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"

# install the auxiliary Faust abstractions (faust-*.pd)
install-pd:
	test -d $(DESTDIR)$(datadir) || mkdir -p $(DESTDIR)$(datadir)
	cp faust-*.pd $(DESTDIR)$(datadir)

#uninstall
uninstall:
	rm -rf $(DESTDIR)$(bindir)/faust2pd$(EXE)
	rm -f $(DESTDIR)$(datadir)/faust-*.pd

.PHONY: dist distcheck

# roll distribution tarball

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir $(dist) && mkdir $(dist)/debian && mkdir $(dist)/pd && mkdir $(dist)/examples
	for x in basic faust seqdemo synth; do mkdir $(dist)/examples/$$x; done
	for x in $(DISTFILES); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,$$PWD/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make all examples && make install install-pd DESTDIR=./BUILD
	rm -rf $(dist)

# Debian packaging

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

# Generate the documentation.

sources = faustxml.pure

faust2pd.txt: README $(sources)
	pure-doc $(sources) | cat README - > $@

=== tools/sound2faust/Makefile ===

DESTDIR ?= 
PREFIX ?= /usr/local

prefix := $(DESTDIR)$(PREFIX)

system	?= $(shell uname -s)

## On Windows (mingw32) we must link against the socket library.
ifneq ($(findstring MINGW32, $(system)),)
LIBS = -lwsock32
EXE = .exe
endif

all : sound2faust sound2file

sound2faust : sound2faust.cpp

	$(CXX) -O3 sound2faust.cpp -I../../architecture `pkg-config --cflags --static --libs sndfile` -o sound2faust $(LIBS)

sound2file : sound2file.cpp

	$(CXX) -O3 sound2file.cpp -I../../architecture `pkg-config --cflags --static --libs sndfile` -o sound2file $(LIBS)

static:

	$(CXX) -O3 sound2faust.cpp -I../../architecture `pkg-config --cflags  sndfile`  /usr/local/lib/libsndfile.a -o sound2faust
	$(CXX) -O3 sound2file.cpp -I../../architecture `pkg-config --cflags  sndfile`  /usr/local/lib/libsndfile.a -o sound2file

install :

	install sound2faust $(prefix)/bin/
	install sound2file $(prefix)/bin/
	install sound2reader $(prefix)/bin/

clean :
	rm -f sound2faust$(EXE) sound2file$(EXE)

=== architecture/android/app/CMakeLists.txt ===
# Sets the minimum version of CMake required to build the native
# library. You should either keep the default value or only pass a
# value of 3.4.0 or lower.

cmake_minimum_required(VERSION 3.4.1)

# Creates and names a library, sets it as either STATIC
# or SHARED, and provides the relative paths to its source code.
# You can define multiple libraries, and CMake builds it for you.
# Gradle automatically packages shared libraries with your APK.

add_library( dsp_faust SHARED src/main/cpp/java_interface_wrap.cpp src/main/cpp/DspFaust.cpp )

# Searches for a specified prebuilt library and stores the path as a
# variable. Because system libraries are included in the search path by
# default, you only need to specify the name of the public NDK library
# you want to add. CMake verifies that the library exists before
# completing its build.

find_library( # Sets the name of the path variable.
              log-lib

              # Specifies the name of the NDK library that
              # you want CMake to locate.
              log )

# Specifies libraries CMake should link to your target library. You
# can link multiple libraries, such as libraries you define in the
# build script, prebuilt third-party libraries, or system libraries.

target_link_libraries( dsp_faust ${log-lib} )

=== architecture/httpdlib/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(HTTPDFaust)

#######################################
# cmake build types configuration
set (CMAKE_CONFIGURATION_TYPES Debug Release)

set (TARGET	HTTPDFaust)
#######################################
# versions management
set (version 0.71)

#######################################
if(WIN32)
	add_definitions(-DWINVER=0x0400 -DWIN32)
  if(MSVC)
	add_definitions(-DMSVC)
  endif(MSVC)
else(WIN32)
	add_definitions(-Wall)
endif(WIN32)

if(APPLE AND (${CMAKE_GENERATOR} STREQUAL Xcode) )
	if (${CMAKE_SYSTEM_VERSION} VERSION_LESS 9.0.0)
		set (CMAKE_OSX_SYSROOT /Developer/SDKs/MacOSX10.4u.sdk)
	elseif (${CMAKE_SYSTEM_VERSION} VERSION_LESS 10.8.0)
		set (CMAKE_OSX_SYSROOT /Developer/SDKs/MacOSX10.5.sdk)
	else ()
		set (CMAKE_OSX_SYSROOT "macosx10.7")
	endif (${CMAKE_SYSTEM_VERSION} VERSION_LESS 9.0.0)

	set (CMAKE_OSX_ARCHITECTURES "x86_64")
	set (CMAKE_C++_FLAGS -mmacosx-version-min=10.4)
endif(APPLE AND (${CMAKE_GENERATOR} STREQUAL Xcode) )

#######################################
# set directories, src and headers.
set (ROOT 			${CMAKE_CURRENT_SOURCE_DIR}/../src)
set (LIBDIR 		${CMAKE_CURRENT_SOURCE_DIR}/../..)
set (SRCFOLDERS 	lib include msg httpd nodes json html)

set(SRC ${SRC} "${ROOT}/*.cpp")						# add source files
foreach(folder ${SRCFOLDERS})
	set(SRC ${SRC} "${ROOT}/${folder}/*.cpp")		# add source files
endforeach(folder)
if (WIN32)
	set(SRC ${SRC} "${ROOT}/threads/win*.cpp")		# add threads src per platform
else (WIN32)
	set(SRC ${SRC} "${ROOT}/threads/pthread*.cpp")	# add threads src per platform
endif (WIN32)

file (GLOB SRCFILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${SRC})

foreach(folder ${SRCFOLDERS})
	set(HEADERS ${HEADERS} "${ROOT}/${folder}/*.h")		# add header files
endforeach(folder)
set(HEADERS ${HEADERS} "${ROOT}/threads/*.h")		# add header files
file (GLOB HEADERFILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${HEADERS})

foreach(folder ${SRCFOLDERS})
	set(INCL ${INCL} "${ROOT}/${folder}")			# add include folders
endforeach(folder)
set(INCL ${INCL} "${LIBDIR}" "${ROOT}/threads" "/usr/local/include")	# add other include folders

#######################################
# set targets
include_directories (${INCL} )

#######################################
# target lib settings
if (STATIC STREQUAL "yes")
	message (STATUS "Generates a static library - Use -DSTATIC=no to change.")
	set (lib "STATIC")
else ()
	message (STATUS "Generates a dynamic library - Use -DSTATIC=yes to change.")
	set (lib "SHARED")
endif ()

add_library ( ${TARGET} ${lib} ${SRCFILES} ${HEADERFILES} )
set_source_files_properties (${HEADERFILES} PROPERTIES HEADER_FILE_ONLY TRUE)
set_target_properties (${TARGET} PROPERTIES 
	VERSION ${version} 
	ARCHIVE_OUTPUT_DIRECTORY "${ROOT}/.."
	ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${ROOT}/.."
)

if(WIN32)
  target_link_libraries ( ${TARGET} ws2_32.lib microhttpd.lib)
 set (OUTLIB "${TARGET}.lib")
else()
  set_target_properties ( ${TARGET} PROPERTIES LINK_FLAGS -L/usr/local/lib )
  target_link_libraries ( ${TARGET} microhttpd )
 set (OUTLIB "lib${TARGET}.a")
endif()

=== architecture/httpdlib/src/Makefile ===
subprojects := html httpd include json lib msg nodes
http_fetcher = ../../../compiler/parser/sourcefetcher.cpp
sources0 = $(wildcard *.cpp) $(wildcard html/*.cpp) $(wildcard httpd/*.cpp)  $(wildcard json/*.cpp) $(wildcard msg/*.cpp) $(wildcard nodes/*.cpp)
sources = $(sources0) $(http_fetcher)
objects = $(sources0:.cpp=.o)
objects += sourcefetcher.o
objects += hexa/jsscripts.o
objects += hexa/stylesheet.o

VPATH = $(subprojects)

system	?= $(shell uname -s)

ifeq ($(system), Darwin)
ARCHFLAGS := -mmacosx-version-min=10.9  # we only support osx from 10.9 and up 
LIB_EXT = dylib
# Darwin/OS X: default installation name prefix for the dynamic library. This
# defaults to the installation prefix (a fixed path) if we have one, but
# depending on usage (plugin or executable) you may want to keep it empty or
# use some generic prefix such as @loader_path/ instead (see below).
ifneq ($(PREFIX),)
INSTALL_PREFIX = $(PREFIX)/lib/
endif
ifneq ($(INSTALL_PREFIX),)
INSTALL_NAME = -install_name "$(INSTALL_PREFIX)libHTTPDFaust.dylib"
endif
else
ARCHFLAGS := 
ifneq ($(findstring MINGW32, $(system)),)
LIB_EXT = dll
else
CXXFLAGS += -fPIC
LIB_EXT = so
endif
endif

# Here are some useful alternative options for the installation name prefix
# (cf., e.g., https://wincent.com/wiki/@executable_path,_@load_path_and_@rpath):

# @executable_path: Useful if the dylib is distributed with an application
# (add path relative to the main executable if needed):
#INSTALL_PREFIX = @executable_path/

# @loader_path (OS X 10.4+): Useful if the dylib is distributed with a plugin
# (add path relative to the plugin if needed):
#INSTALL_PREFIX = @loader_path/

# @rpath (OS X 10.5+): Useful if the dylib is distributed with an application
# which has an rpath coded into it:
#INSTALL_PREFIX = @rpath/

CXXFLAGS ?= -O3 -Wall -Wuninitialized
CXXFLAGS += `pkg-config --cflags libmicrohttpd` -I../../../architecture -I../../../compiler/tlib -I/usr/local/include -Wno-parentheses $(addprefix -I, $(subprojects)) -DINSTALL_PREFIX='"$(prefix)"' $(ARCHFLAGS)

all: ../libHTTPDFaust.a

dynamic : ../libHTTPDFaust.$(LIB_EXT)

sourcefetcher.o: $(http_fetcher)
	$(CXX) $(CXXFLAGS) -fPIC $(http_fetcher) -c -o sourcefetcher.o
	
../libHTTPDFaust.a : $(objects)
	rm -f $@
	ar cq $@ $(objects)
	ranlib $@

../libHTTPDFaust.dylib :  $(objects)
	$(CXX) -dynamiclib $(INSTALL_NAME) $(ARCHFLAGS) $(objects) `pkg-config --libs libmicrohttpd` -o $@

../libHTTPDFaust.so  :  $(objects)
	$(CXX) -shared -fPIC $(LDFLAGS) -o $@ $(objects) `pkg-config --libs libmicrohttpd`

../libHTTPDFaust.dll  :  $(objects)
	$(CXX) -shared $(LDFLAGS) -o $@ $(objects) `pkg-config --libs libmicrohttpd` -lwsock32
	
depend :
	makedepend -fMakefile -w120 -Y -- $(CXXFLAGS) -- $(sources)
	
clean :
	rm -f $(objects) hexa/jsscripts hexa/jsscripts.cpp
	rm -f $(objects) hexa/stylesheet hexa/stylesheet.cpp
	rm -f ../libHTTPDFaust.a ../libHTTPDFaust.dylib ../libHTTPDFaust.so ../libHTTPDFaust.dll
	

hexa/jsscripts.o : hexa/jsscripts.cpp

hexa/stylesheet.o : hexa/stylesheet.cpp

hexa/jsscripts.cpp : hexa/jsscripts
	cd hexa; xxd -i jsscripts jsscripts.cpp

hexa/stylesheet.cpp : hexa/stylesheet
	cd hexa; xxd -i stylesheet stylesheet.cpp

hexa/jsscripts : ../html/js/svg/*.js ../html/js/svg/jquerysvg/jquery.svg.js
	cat ../html/js/svg/jquery-1.7.1.min.js > $@
	echo " " >> $@
	cat ../html/js/svg/jquerysvg/jquery.svg.min.js >> $@
	echo " " >> $@
	cat ../html/js/svg/jquerysvg/jquery.svgdom.min.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_proto.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_jquery_svg_backend.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_mobile.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_ui_inits.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_load_external_file.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_ui_objects.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_ui_builder.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_ui_interact.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_ui_audio_bridge.js >> $@
	echo " " >> $@
	cat ../html/js/svg/faust_server_communication.js >> $@

hexa/stylesheet : ../html/js/svg/faust_css.css
	cat ../html/js/svg/faust_css.css > $@

# DO NOT DELETE

HTTPDControler.o: include/HTTPDControler.h nodes/FaustFactory.h nodes/MessageDriven.h msg/MessageProcessor.h
HTTPDControler.o: lib/smartpointer.h nodes/FaustNode.h msg/Message.h httpd/HTTPDSetup.h json/jsonfactory.h
HTTPDControler.o: json/jsonroot.h json/jsonnode.h json/jsoncontrol.h html/htmlfactory.h html/htmlpage.h
HTTPDControler.o: nodes/RootNode.h
html/htmlfactory.o: html/htmlfactory.h html/htmlpage.h
html/htmlpage.o: lib/deelx.h html/htmlpage.h html/jsscripts.h html/stylesheet.h
html/htmlui.o: html/htmlui.h html/htmlfactory.h html/htmlpage.h
httpd/Address.o: httpd/Address.h
httpd/HTTPDServer.o: httpd/HTTPDServer.h msg/Message.h lib/smartpointer.h msg/MessageProcessor.h
httpd/HTTPDSetup.o: httpd/HTTPDSetup.h httpd/HTTPDServer.h msg/MessageProcessor.h
json/jsoncontrol.o: json/jsoncontrol.h json/jsonnode.h lib/smartpointer.h
json/jsonfactory.o: json/jsonfactory.h json/jsonroot.h lib/smartpointer.h json/jsonnode.h json/jsoncontrol.h
json/jsonfactory.o: json/jsongroup.h
json/jsonfaustui.o: include/jsonfaustui.h ../../../architecture/faust/gui/meta.h ../../../architecture/faust/gui/UI.h
json/jsonfaustui.o: json/jsonui.h json/jsonfactory.h json/jsonroot.h lib/smartpointer.h json/jsonnode.h
json/jsonfaustui.o: json/jsoncontrol.h
json/jsongroup.o: json/jsongroup.h json/jsonnode.h lib/smartpointer.h
json/jsonroot.o: json/jsonroot.h lib/smartpointer.h json/jsonnode.h
json/jsonui.o: json/jsonui.h json/jsonfactory.h json/jsonroot.h lib/smartpointer.h json/jsonnode.h json/jsoncontrol.h
msg/Message.o: msg/Message.h lib/smartpointer.h
nodes/FaustFactory.o: nodes/FaustFactory.h nodes/MessageDriven.h msg/MessageProcessor.h lib/smartpointer.h
nodes/FaustFactory.o: nodes/FaustNode.h msg/Message.h nodes/RootNode.h
nodes/FaustNode.o: nodes/FaustNode.h nodes/MessageDriven.h msg/MessageProcessor.h lib/smartpointer.h msg/Message.h
nodes/FaustNode.o: httpd/HTTPDServer.h
nodes/MessageDriven.o: httpd/Address.h msg/Message.h lib/smartpointer.h nodes/MessageDriven.h msg/MessageProcessor.h
nodes/MessageDriven.o: httpd/HTTPDServer.h
nodes/RootNode.o: nodes/RootNode.h nodes/MessageDriven.h msg/MessageProcessor.h lib/smartpointer.h msg/Message.h
../../../compiler/parser/sourcefetcher.o: ../../../compiler/tlib/compatibility.hh
../../../compiler/parser/sourcefetcher.o: ../../../compiler/parser/sourcefetcher.hh

=== architecture/osclib/faust/Makefile ===
subprojects := . src src/lib src/msg src/nodes src/osc src/threads ../..
sources = $(sort $(wildcard src/*.cpp) $(wildcard src/*/*.cpp))
objects = $(sources:.cpp=.o)

VPATH = $(subprojects)

system	?= $(shell uname -s)

# Darwin/OS X: default installation name prefix for the dynamic library. This
# defaults to the installation prefix (a fixed path) if we have one, but
# depending on usage (plugin or executable) you may want to keep it empty or
# use some generic prefix such as @loader_path/ instead (see below).

ifneq ($(PREFIX),)
	INSTALL_PREFIX = $(PREFIX)/lib/
endif

# Here are some useful alternative options for the installation name prefix
# (cf., e.g., https://wincent.com/wiki/@executable_path,_@load_path_and_@rpath):

# @executable_path: Useful if the dylib is distributed with an application
# (add path relative to the main executable if needed):
#INSTALL_PREFIX = @executable_path/

# @loader_path (OS X 10.4+): Useful if the dylib is distributed with a plugin
# (add path relative to the plugin if needed):
#INSTALL_PREFIX = @loader_path/

# @rpath (OS X 10.5+): Useful if the dylib is distributed with an application
# which has an rpath coded into it:
#INSTALL_PREFIX = @rpath/

ifeq ($(system), Darwin)
	ARCHFLAGS := -mmacosx-version-min=10.9  # we only support osx from 10.9 and up 
else
	ARCHFLAGS := 
	ifeq ($(findstring MINGW32, $(system)),)
		CXXFLAGS += -fPIC
	endif
endif

ifeq ($(MODE), SHARED)
	ifeq ($(system), Darwin)
		TARGET=libOSCFaust.$(VERSION).dylib
		SONAME=libOSCFaust.$(SOVERSION).dylib
		ifneq ($(INSTALL_PREFIX),)
			INSTALL_NAME = -install_name "$(INSTALL_PREFIX)$(SONAME)"
		endif
	else
		ifneq ($(findstring MINGW32, $(system)),)
			TARGET=libOSCFaust-$(VERSION).dll
			SONAME=libOSCFaust-$(SOVERSION).dll
		else
			TARGET=libOSCFaust.so.$(VERSION)
			SONAME=libOSCFaust.so.$(SOVERSION)
		endif
	endif
else
	TARGET=libOSCFaust.a
endif


CXXFLAGS ?= -O3 -Wall -Wuninitialized 
CXXFLAGS += -Wno-parentheses -I../oscpack -I../oscpack/osc $(addprefix -I, $(subprojects)) -DINSTALL_PREFIX='"$(prefix)"' $(ARCHFLAGS)

all : $(TARGET)

libOSCFaust.$(VERSION).dylib : $(objects)
	$(CXX) -dynamiclib $(INSTALL_NAME) -compatibility_version $(SOVERSION) -current_version $(VERSION) $(ARCHFLAGS) $(objects) -L.. -loscpack -o libOSCFaust.$(VERSION).dylib

libOSCFaust.so.$(VERSION) : $(objects)
	$(CXX) -shared -Wl,-soname,$(SONAME) -fPIC $(ARCHFLAGS) $(LDFLAGS) $(objects) -L.. -loscpack -o libOSCFaust.so.$(VERSION)

libOSCFaust-$(VERSION).dll : $(objects)
	$(CXX) -shared $(ARCHFLAGS) $(LDFLAGS) $(objects) -L.. -loscpack -lwsock32 -lws2_32 -lwinmm -o libOSCFaust-$(VERSION).dll

libOSCFaust.a : $(objects)
	rm -f $@
	ar cq $@ $(objects)
	ranlib $@
	

ios: IPHONEOS_DEPLOYMENT_TARGET=5.0
ios: CXX = /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/clang++ 
ios: CXXFLAGS += -std=c++11 -stdlib=libstdc++ -arch armv7 -arch armv7s -arch arm64 -pipe -O3 -gdwarf-2 -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS7.1.sdk
ios: CXXFLAGS += -fvisibility=hidden -Wno-overloaded-virtual -Wno-parentheses $(addprefix -I, $(subprojects)) -DINSTALL_PREFIX='"$(prefix)"' 

ios : libOSCFaust.a 
	
depend :
	makedepend -fMakefile -w120 -Y -- $(CXXFLAGS) -- $(sources)
	
clean :
	rm -f $(objects)
	rm -f libOSCFaust.a libOSCFaust*.dylib libOSCFaust.so* libOSCFaust*.dll
	


# DO NOT DELETE

src/OSCControler.o: faust/OSCControler.h faust/osc/FaustFactory.h faust/osc/FaustNode.h faust/osc/MessageDriven.h
src/OSCControler.o: faust/osc/MessageProcessor.h faust/osc/smartpointer.h faust/osc/Message.h ../../faust/gui/GUI.h
src/OSCControler.o: ../../faust/gui/UI.h ../../faust/gui/ring-buffer.h faust/osc/RootNode.h faust/OSCIO.h
src/OSCControler.o: src/osc/OSCSetup.h src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h
src/OSCControler.o: ../oscpack/osc/OscTypes.h ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h
src/OSCControler.o: ../oscpack/ip/NetworkingUtils.h ../oscpack/ip/IpEndpointName.h src/lib/OSCFError.h
src/OSCControler.o: src/lib/OSCRegexp.h src/lib/deelx.h
src/lib/OSCFError.o: src/lib/OSCFError.h src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h
src/lib/OSCFError.o: ../oscpack/osc/OscTypes.h ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h
src/lib/OSCFError.o: ../oscpack/ip/NetworkingUtils.h ../oscpack/ip/IpEndpointName.h faust/osc/Message.h
src/lib/OSCFError.o: faust/osc/smartpointer.h
src/lib/OSCRegexp.o: src/lib/OSCRegexp.h src/lib/deelx.h
src/msg/Message.o: faust/osc/Message.h faust/osc/smartpointer.h src/lib/OSCFError.h src/osc/OSCStream.h
src/msg/Message.o: ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h ../oscpack/osc/OscException.h
src/msg/Message.o: ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h ../oscpack/ip/IpEndpointName.h
src/nodes/FaustFactory.o: faust/osc/FaustFactory.h faust/osc/FaustNode.h faust/osc/MessageDriven.h
src/nodes/FaustFactory.o: faust/osc/MessageProcessor.h faust/osc/smartpointer.h faust/osc/Message.h
src/nodes/FaustFactory.o: ../../faust/gui/GUI.h ../../faust/gui/UI.h ../../faust/gui/ring-buffer.h faust/osc/RootNode.h
src/nodes/FaustFactory.o: src/osc/OSCAddress.h
src/nodes/FaustNode.o: faust/osc/FaustNode.h faust/osc/MessageDriven.h faust/osc/MessageProcessor.h
src/nodes/FaustNode.o: faust/osc/smartpointer.h faust/osc/Message.h ../../faust/gui/GUI.h ../../faust/gui/UI.h
src/nodes/FaustNode.o: ../../faust/gui/ring-buffer.h faust/osc/RootNode.h faust/OSCControler.h faust/osc/FaustFactory.h
src/nodes/FaustNode.o: src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h
src/nodes/FaustNode.o: ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h
src/nodes/FaustNode.o: ../oscpack/ip/IpEndpointName.h
src/nodes/MessageDriven.o: faust/osc/Message.h faust/osc/smartpointer.h faust/osc/MessageDriven.h
src/nodes/MessageDriven.o: faust/osc/MessageProcessor.h src/osc/OSCAddress.h src/lib/OSCFError.h src/osc/OSCStream.h
src/nodes/MessageDriven.o: ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h
src/nodes/MessageDriven.o: ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h
src/nodes/MessageDriven.o: ../oscpack/ip/IpEndpointName.h src/lib/OSCRegexp.h src/lib/deelx.h
src/nodes/RootNode.o: faust/OSCControler.h faust/osc/FaustFactory.h faust/osc/FaustNode.h faust/osc/MessageDriven.h
src/nodes/RootNode.o: faust/osc/MessageProcessor.h faust/osc/smartpointer.h faust/osc/Message.h ../../faust/gui/GUI.h
src/nodes/RootNode.o: ../../faust/gui/UI.h ../../faust/gui/ring-buffer.h faust/osc/RootNode.h faust/OSCIO.h
src/nodes/RootNode.o: src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h
src/nodes/RootNode.o: ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h
src/nodes/RootNode.o: ../oscpack/ip/IpEndpointName.h ../oscpack/ip/NetworkingUtils.h
src/osc/OSCAddress.o: src/osc/OSCAddress.h
src/osc/OSCIO.o: faust/OSCIO.h src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h
src/osc/OSCIO.o: ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h
src/osc/OSCIO.o: ../oscpack/ip/IpEndpointName.h
src/osc/OSCListener.o: faust/osc/Message.h faust/osc/smartpointer.h src/osc/OSCListener.h faust/osc/MessageProcessor.h
src/osc/OSCListener.o: ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h ../oscpack/ip/IpEndpointName.h
src/osc/OSCListener.o: ../oscpack/osc/OscPacketListener.h ../oscpack/osc/OscReceivedElements.h
src/osc/OSCListener.o: ../oscpack/osc/OscTypes.h ../oscpack/osc/OscException.h ../oscpack/ip/PacketListener.h
src/osc/OSCListener.o: src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h
src/osc/OSCListener.o: ../oscpack/osc/OscReceivedElements.h ../oscpack/ip/IpEndpointName.h
src/osc/OSCSetup.o: src/osc/OSCSetup.h src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h
src/osc/OSCSetup.o: ../oscpack/osc/OscTypes.h ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h
src/osc/OSCSetup.o: ../oscpack/ip/NetworkingUtils.h ../oscpack/ip/IpEndpointName.h src/threads/TThreads.h
src/osc/OSCSetup.o: src/osc/OSCListener.h faust/osc/smartpointer.h faust/osc/MessageProcessor.h
src/osc/OSCSetup.o: ../oscpack/osc/OscPacketListener.h ../oscpack/osc/OscReceivedElements.h
src/osc/OSCSetup.o: ../oscpack/ip/PacketListener.h
src/osc/OSCStream.o: src/osc/OSCStream.h ../oscpack/osc/OscOutboundPacketStream.h ../oscpack/osc/OscTypes.h
src/osc/OSCStream.o: ../oscpack/osc/OscException.h ../oscpack/ip/UdpSocket.h ../oscpack/ip/NetworkingUtils.h
src/osc/OSCStream.o: ../oscpack/ip/IpEndpointName.h
src/threads/pthreads_impl.o: src/threads/TThreads.h

=== architecture/osclib/oscpack/Makefile ===
libname     := liboscpack.a
system		?= $(shell uname -s)

ifeq ($(system), Darwin)
subprojects := ip ip/posix osc
sources     := $(sort $(wildcard ip/*.cpp)  $(wildcard ip/posix/*.cpp)  $(wildcard osc/*.cpp))
ARCHFLAGS 	:=  -mmacosx-version-min=10.9

else
ifeq ($(system), Linux)
subprojects := ip ip/posix osc
sources     := $(sort $(wildcard ip/*.cpp)  $(wildcard ip/posix/*.cpp)  $(wildcard osc/*.cpp))
ARCHFLAGS 	:=
CXXFLAGS += -fPIC

else
ifeq ($(system), GNU/kFreeBSD)
subprojects := ip ip/posix osc
sources     := $(sort $(wildcard ip/*.cpp)  $(wildcard ip/posix/*.cpp)  $(wildcard osc/*.cpp))
ARCHFLAGS      :=

else
subprojects := ip ip/win32 osc
sources     := $(sort $(wildcard ip/*.cpp)  $(wildcard ip/win32/*.cpp)  $(wildcard osc/*.cpp))
ARCHFLAGS 	:=
endif
endif
endif

VPATH = $(subprojects)

CXXFLAGS ?= -O3 -Wall -Wuninitialized
CXXFLAGS += -Wno-parentheses -I. $(addprefix -I, $(subprojects)) $(ARCHFLAGS)

objects := $(sources:.cpp=.o)


## TARGETS

all: $(libname)

$(libname): $(objects)
	rm -f $@
	ar cq $@ $(objects)
	ranlib $@

depend :
	makedepend -fMakefile -w120 -Y -- $(CXXFLAGS) -- $(sources)

ios: IPHONEOS_DEPLOYMENT_TARGET=5.0
ios: CXX = /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin/clang++
ios: CXXFLAGS += -std=c++11 -stdlib=libstdc++  -arch armv7 -arch armv7s -arch arm64 -pipe -O3 -gdwarf-2 -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS7.1.sdk
ios: CXXFLAGS += -fvisibility=hidden -Wno-overloaded-virtual -Wno-parentheses $(addprefix -I, $(subprojects)) -DINSTALL_PREFIX='"$(prefix)"'

ios : liboscpack.a

clean :
	rm -f $(objects)
	rm -f $(libname)


# DO NOT DELETE

ip/IpEndpointName.o: ip/IpEndpointName.h ip/NetworkingUtils.h
ip/posix/NetworkingUtils.o: ip/NetworkingUtils.h
ip/posix/UdpSocket.o: ip/UdpSocket.h ip/NetworkingUtils.h ip/IpEndpointName.h ip/PacketListener.h ip/TimerListener.h
osc/OscOutboundPacketStream.o: osc/OscOutboundPacketStream.h osc/OscTypes.h osc/OscException.h osc/OscHostEndianness.h
osc/OscPrintReceivedElements.o: osc/OscPrintReceivedElements.h osc/OscReceivedElements.h osc/OscTypes.h
osc/OscPrintReceivedElements.o: osc/OscException.h
osc/OscReceivedElements.o: osc/OscReceivedElements.h osc/OscTypes.h osc/OscException.h osc/OscHostEndianness.h
osc/OscTypes.o: osc/OscTypes.h

=== debian/changelog ===
faust (0.9.95~repack1-2) unstable; urgency=medium

  * faust sources are now in /usr/share/faust/
  * Fixed install mess
  * Mark faust-common as Multi-Arch:foreign
  * Updated d/copyright

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 04 Jan 2017 11:34:30 +0100

faust (0.9.95~repack1-1) unstable; urgency=medium

  * New upstream version 0.9.95~repack1 (Closes: #715891)

  * Removed patches applied upstream.
  * Adjusted install targets to README->README.md rename
  * Dropped unneeded hack to copy files from /usr/lib/ to /usr/share/
  * Made sure that code files are non-executable

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 03 Jan 2017 16:35:39 +0100

faust (0.9.90~repack1-1) unstable; urgency=medium

  * New upstream version 0.9.90~repack1

  * Refreshed patches.
    * Added '.patch' suffix to Debian-patches
  * Added new patches
    * Closed privacy breach
    * Fixed 'make clean' target
  * Factored out binary package "faust-common"
  * Removed binary build-artefacts from /usr/share
  * Added missing sources
    * (pseudo) build-target 'missing-sources' to automate this
  * Added lintian-override for .dsp project files
  * Added local-options to d/source/
  * Added gbp config
  * Updated d/copyright
  * Installed WHATSNEW as upstream changelog

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 27 Sep 2016 22:06:12 +0200

=== debian/control ===
Source: faust
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 9),
 dh-exec (>= 0.13),
 help2man,
 ruby,
 bison, flex
Homepage: http://faust.grame.fr/
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/faust.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/faust.git

Package: faust
Architecture: any
Depends:
 ${misc:Depends}, ${shlibs:Depends},
 faust-common (>= ${source:Version}), faust-common (<< ${source:Upstream-Version}+1~),
Recommends: python, ruby, libc6-dev | libc-dev, g++, make, libjack-dev, libgtk2.0-dev
Suggests: kate
Description: functional programming language for realtime audio applications
 Faust is a functional programming language specifically designed for realtime
 audio applications and plugins. The syntax of the language is block diagram
 oriented. The faust compiler translate signal processing specifications into
 optimized C++ code for signal processing applications.
 .
 The generated code can be wrapped into an 'architecture file' in order to
 create for example a standalone jack/gtk application. Several architecture
 file are provided and additional ones are fairly easy to add.

Package: faust-common
Architecture: all
Multi-Arch: foreign
Breaks: faust (<< 0.9.90~repack1-1),
Replaces: faust (<< 0.9.90~repack1-1),
Depends:
 ${misc:Depends},
Description: functional programming language for realtime audio applications - common files
 Faust is a functional programming language specifically designed for realtime
 audio applications and plugins. The syntax of the language is block diagram
 oriented. The faust compiler translate signal processing specifications into
 optimized C++ code for signal processing applications.
 .
 The generated code can be wrapped into an 'architecture file' in order to
 create for example a standalone jack/gtk application. Several architecture
 file are provided and additional ones are fairly easy to add.
 .
 This package contains the architecture independent files for faust.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2016 IOhannes m zmölnig <zmoelnig@iem.at>
# Description: Main Debian packaging script for faust
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
#include /usr/share/cdbs/1/rules/utils.mk

DEB_MAKE_ENVVARS = CFLAGS="$(or $(CFLAGS_$(cdbs_curpkg)),$(CFLAGS))" CXXFLAGS="$(or $(CXXFLAGS_$(cdbs_curpkg)),$(CXXFLAGS))" CPPFLAGS="$(or $(CPPFLAGS_$(cdbs_curpkg)),$(CPPFLAGS))" LDFLAGS="$(or $(LDFLAGS_$(cdbs_curpkg)),$(LDFLAGS))"
DEB_MAKE_EXTRA_ARGS = $(DEB_MAKE_PARALLEL) PREFIX=/usr
DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(cdbs_make_curdestdir)

DEB_INSTALL_CHANGELOGS_ALL=WHATSNEW

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        ^(.*\.(png|pdf|doctree|jar|xcuserstate|swc|ots)|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_COMPRESS_EXCLUDE_ALL=.dsp .lib Makefile
MANPAGEDIR=debian/man

.PHONY: manpages manpageclean
manpages:
	mkdir -p $(MANPAGEDIR)
	help2man -N -n "functional programming language for realtime audio applications" \
		debian/faust-help2man > $(MANPAGEDIR)/faust.1
	help2man -N -n "Compile faust DSP code into SuperCollider module" \
		tools/faust2sc-1.0.0/faust2sc > $(MANPAGEDIR)/faust2sc.1
	debian/faust2man $(MANPAGEDIR) debian/faust2api.1
manpageclean:
	-rm -rf $(MANPAGEDIR)
common-binary-arch:: manpages
clean:: manpageclean

binary-post-install/faust::
	# fix path for faustpath and faustoptflags
	sed -e 's|^\( *\. \)faust|\1/usr/share/faust/utils/faust|' \
		-i $(CURDIR)/debian/$(cdbs_curpkg)/usr/bin/faust2*
binary-post-install/faust-common::
	# remove binary artifacts from to-be /usr/share
	rm -rf $(CURDIR)/debian/$(cdbs_curpkg)/usr/share/faust/iOS/osclib/
	# fix permissions
	find $(CURDIR)/debian/$(cdbs_curpkg)/usr/share/faust -name "*.cpp" \
		-exec chmod a-x {} +
	find $(CURDIR)/debian/$(cdbs_curpkg)/usr/share/faust -name "*.jucer" \
		-exec chmod a-x {} +

.PHONY: missing-sources
missing-sources: debian/missing-sources/jquery-1.4.2.js
debian/missing-sources/jquery-1.4.2.js:
	wget -O $@ https://raw.githubusercontent.com/jquery/jquery/1.4.2/jquery.js
missing-sources: debian/missing-sources/jquery-1.7.1.js
debian/missing-sources/jquery-1.7.1.js:
	wget -O $@ https://raw.githubusercontent.com/jquery/jquery/1.7.1/jquery.js
missing-sources: debian/missing-sources/underscore-0.5.5.js
debian/missing-sources/underscore-0.5.5.js:
	wget -O $@ https://raw.githubusercontent.com/jashkenas/underscore/0.5.5/underscore.js

=== debian/watch ===
# process this file with uscan(1)
version=3
opts=dversionmangle=s/~(dfsg|repack)(\.?[0-9]*)?$// \
  http://sf.net/faudiostream/faust-(0\.\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
